<template>
    <SfSidebar v-if="isGuide"
               class="sw-gs-presentation-layer sf-sidebar--right"
               position="right"
               :class="sidebarClasses"
               title="Presentation Layer"
               :button="false"
               visible
               :persistent="true"
               :overlay="false"
               :style="'position:' + positionState">
        <template #title>
            <SwPluginSlot name="gs-layer-top" div class="sw-gs-presentation-layer-top"
                          :class="{'has-video': callEnabled, 'has-video-fullscreen-modal': isFullscreenVideoModalOpen }">

                <template v-if="ended && sizeState === 'maximized'">
                    <div class="sw-gs-ended-presentation">
                        <h5>{{ $t('Appointment ended')}}</h5>
                    </div>
                </template>
                <template v-else-if="isSelfService">
                </template>
                <template v-else-if="callEnabled">
                    <SwGsLayerVideoGuide/>
                </template>
                <template v-else-if="sizeState === 'maximized'">
                    <SwGsStartAppointment v-if="!running"/>
                    <SwGsEndAppointment v-else-if="!ended"/>
                </template>

                <div class="sw-gs-presentation-layer-top-actions" :class="{'hide-actions': isInstantListingModalOpen}">
                    <SwButton class="sw-gs-presentation-layer-toggle-size is-circle color-light"
                              :title="$t('Toggle layer size')"
                              @click="toggleSideBar">
                        <SwGsIconCircleRight class="color-dark-secondary size-sm minimize"/>
                        <SwGsIconCircleLeft class="color-dark-secondary size-sm maximize"/>
                    </SwButton>

                    <SwButton class="sw-gs-presentation-layer-toggle-position is-circle color-light"
                              :title="$t('Toggle layer position')"
                              @click="toggleLayerPosition">
                        <SwGsIconLayerStatic class="color-dark-secondary size-sm static"/>
                        <SwGsIconLayerFixed class="color-dark-secondary size-sm fixed"/>
                    </SwButton>
                </div>
            </SwPluginSlot>

            <SwPluginSlot name="gs-layer-between"/>
        </template>

        <SwPluginSlot name="gs-layer-widgets">
            <SwGsLayerWidgets v-if="sizeState === 'maximized'"/>
        </SwPluginSlot>

    </SfSidebar>
</template>

<script lang="ts">
import { computed, onMounted } from '@vue/composition-api';
import { useAppointment } from "../../logic/composables/useAppointment";
import { usePresentationLayer } from "../../logic/composables/usePresentationLayer";
import { usePresentation } from "../../logic/composables/usePresentation";
import { useState } from "../../logic/composables/useState";
import { useClearBodyScrollLock } from "../../logic/composables/useClearBodyScrollLock";
import { useUIState } from "@shopware-pwa/composables";
import { SfSidebar } from "@storefront-ui/vue"
import { SwGsIconCircleRight, SwGsIconCircleLeft, SwGsIconLayerStatic, SwGsIconLayerFixed } from "../icons";
import { useInstantListing } from "../../logic/composables/useInstantListing";
import { useVideoCall } from '../../logic/composables/useVideoCall';

import SwGsLayerVideoGuide from "./SwGsLayerVideoGuide.vue";
import SwGsLayerWidgets from "./SwGsLayerWidgets.vue";
import SwButton from "@/components/atoms/SwButton.vue";
import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
import SwGsStartAppointment from '../SwGsStartAppointment.vue';
import SwGsEndAppointment from '../SwGsEndAppointment.vue';

export default {
    name: "SwGsLayer",
    components: {
        SwGsIconCircleRight,
        SwGsIconCircleLeft,
        SwGsIconLayerStatic,
        SwGsIconLayerFixed,
        SfSidebar,
        SwGsLayerWidgets,
        SwButton,
        SwGsLayerVideoGuide,
        SwGsStartAppointment,
        SwGsEndAppointment,
        SwPluginSlot
    },

    setup() {
        const { isGuide, isSelfService } = useAppointment();
        const { toggleLayerSize, toggleLayerPosition, sidebarClasses, sizeState, positionState } = usePresentationLayer();
        const { currentSlideIndex } = usePresentation();
        const { stateForAll, ended } = useState();
        const { isInstantListingModalOpen } = useInstantListing();
        const { clearBodyScrollLock } = useClearBodyScrollLock();
        const { isOpen: isFullscreenVideoModalOpen } = useUIState({ stateName: "GS_VIDEO_FULLSCREEN_MODAL_STATE" });
        const { isOpen: isVideoSettingsModalOpen } = useUIState({ stateName: "GS_VIDEO_MODAL_STATE" });
        const { callEnabled } = useVideoCall();

        onMounted(() => {
            clearBodyScrollLock();
        });

        const toggleSideBar = () => {
            toggleLayerSize();
        };

        return {
            toggleSideBar,
            isFullscreenVideoModalOpen,
            isVideoSettingsModalOpen,
            isGuide,
            toggleLayerPosition,
            isInstantListingModalOpen,
            sidebarClasses,
            sizeState,
            positionState,
            isSelfService,
            currentSlideIndex,
            callEnabled,
            running: computed(() => stateForAll?.value?.running),
            ended
        }
    }
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

.sw-gs-presentation-layer {
    height: 100%;

    ::v-deep .sf-bar {
        display: none;
    }

    .sw-gs-presentation-layer-toggle-position {
        .sf-icon {
            &.static {
                display: block;
            }

            &.fixed {
                display: none;
            }
        }
    }

    &.static {
        ::v-deep .sf-sidebar__aside {
            position: static;
            flex: 0 0 auto;
            height: 100vh;
            border-left: 1px solid var(--_c-gray-accent);
            box-shadow: rgba(149, 157, 165, 0.2) 0 8px 24px;
        }
    }

    .sw-gs-presentation-layer-toggle-position {
        .sf-icon {
            &.static {
                display: none;
            }

            &.fixed {
                display: block;
            }
        }
    }

    .sw-gs-presentation-layer-toggle-size {
        .sf-icon {
            &.minimize {
                display: block;
            }

            &.maximize {
                display: none;
            }
        }
    }

    &.minimized {

        .sw-gs-presentation-layer-top-actions {
            left: var(--spacer-xs) !important;
        }

        .sw-gs-presentation-layer-toggle-size {
            .sf-icon {
                &.minimize {
                    display: none;
                }

                &.maximize {
                    display: block;
                }
            }
        }

        ::v-deep .sf-sidebar__aside {
            background-color: var(--c-dark-variant);
            width: var(--presentation-layer-width-minimized);

            .sf-sidebar__content {
                display: none;
            }

            .sf-sidebar__top {
                height: 100%;

                .sw-gs-presentation-layer-top {
                    height: 100%;
                    min-height: auto;
                }
            }
        }
    }
}

.sw-gs-presentation-layer-top {
    position: relative;
    min-height: 100px;

    .sw-gs-presentation-layer-top-actions {
        padding: var(--spacer-xs) 0 0 var(--spacer-xs);
        transition: left 0.25s ease-in;

        &.hide-actions {
            display: none;
        }
    }

    &.has-video-fullscreen-modal {
        .sw-gs-presentation-layer-top-actions {
            left: var(--spacer-xs) !important;
        }
    }

    &.has-video {
        .sw-gs-presentation-layer-top-actions {
            padding: 0;
            position: absolute;
            left: -20px;
            top: var(--spacer-xs);
        }
    }

    &:not(.has-video) {
        ::v-deep .sw-gs-ended-presentation {
            position: absolute;
            width: 100%;
            height: 100%;
            display: flex;
            align-items: center;
            justify-content: center;
        }

        ::v-deep .sw-gs-end-presentation {
            position: absolute;

            .sw-gs-end-presentation-btn {
                z-index: var(--helper-lay-over-sibling-z-index);
            }
        }
    }

    ::v-deep .sw-gs-start-presentation {
        position: absolute;

        .sw-gs-start-presentation-btn {
            z-index: var(--helper-lay-over-sibling-z-index);
        }
    }
}

::v-deep .sf-sidebar__top,
::v-deep .sf-sidebar__content {
    padding: 0;
}

.sw-gs-presentation-layer-toggle-size,
.sw-gs-presentation-layer-toggle-position {
    margin-bottom: 10px;
}

.sw-gs-presentation-layer-toggle-size .sf-icon {
    transition: all 0.3s ease-in-out;
}

::v-deep .sf-sidebar__aside {
    position: fixed;
    z-index: var(--presentation-layer-z-index);
    left: auto;
    right: 0; // reset mobile styles of sidebar to collapse to the left
    transition: width 0.3s ease-in-out;
    max-width: 100%;
    border-left: 1px solid var(--_c-gray-accent);
    box-shadow: rgba(149, 157, 165, 0.2) 0 8px 24px;
    --sidebar-width: var(--presentation-layer-width-maximized-mobile);

    @include for-tablet {
        --sidebar-width: var(--presentation-layer-width-maximized);
    }
}

@include for-mobile {
    .sw-gs-presentation-layer-toggle-position {
        display: none;
    }
}
</style>
